Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/HeuristicLab.Clients.Hive.Administrator-3.3.csproj
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/HeuristicLab.Clients.Hive.Administrator-3.3.csproj	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/HeuristicLab.Clients.Hive.Administrator-3.3.csproj	(revision 15908)
@@ -284,9 +284,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="Views\ProjectView.resx">
-      <DependentUpon>ProjectView.cs</DependentUpon>
-    </EmbeddedResource>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 15908)
@@ -24,5 +24,4 @@
     /// </summary>
     private void InitializeComponent() {
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ProjectView));
       this.idLabel = new System.Windows.Forms.Label();
       this.idTextBox = new System.Windows.Forms.TextBox();
@@ -193,5 +192,5 @@
       // refreshButton
       // 
-      this.refreshButton.Image = ((System.Drawing.Image)(resources.GetObject("refreshButton.Image")));
+      this.refreshButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
       this.refreshButton.Location = new System.Drawing.Point(72, 162);
       this.refreshButton.Name = "refreshButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Access.DataAccess/3.3/AccessService.dbml
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Access.DataAccess/3.3/AccessService.dbml	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Access.DataAccess/3.3/AccessService.dbml	(revision 15908)
@@ -1,4 +1,4 @@
 ﻿<?xml version="1.0" encoding="utf-8"?><Database Name="HeuristicLab.ClientManagement" Class="AccessServiceDataContext" xmlns="http://schemas.microsoft.com/linqtosql/dbml/2007">
-  <Connection Mode="AppSettings" ConnectionString="Data Source=HIVELAB;Integrated Security=SSPI;Initial Catalog=HeuristicLab.AccessService" SettingsObjectName="HeuristicLab.Services.Access.DataAccess.Properties.Settings" SettingsPropertyName="HeuristicLab_ClientManagementConnectionString" Provider="System.Data.SqlClient" />
+  <Connection Mode="AppSettings" ConnectionString="Data Source=localhost;Integrated Security=SSPI;Initial Catalog=HeuristicLab.AccessService" SettingsObjectName="HeuristicLab.Services.Access.DataAccess.Properties.Settings" SettingsPropertyName="HeuristicLab_ClientManagementConnectionString" Provider="System.Data.SqlClient" />
   <Table Name="dbo.Resource" Member="Resources">
     <Type Name="Resource" InheritanceCode="Resource" IsInheritanceDefault="true">
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/HiveStatistics/DimProjectDao.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/HiveStatistics/DimProjectDao.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/HiveStatistics/DimProjectDao.cs	(revision 15908)
@@ -55,5 +55,5 @@
         (from dimProject in db.GetTable<DimProject>()
          where dimProject.ProjectId == projectId
-         select dimProject).ToList());
+         select dimProject));
     private static readonly Func<DataContext, Guid, Guid> GetLastValidIdByProjectIdQuery =
       CompiledQuery.Compile((DataContext db, Guid projectId) =>
@@ -67,5 +67,5 @@
         (from dimProject in db.GetTable<DimProject>()
          where dimProject.DateExpired == null
-         select dimProject).ToList());
+         select dimProject));
     #endregion
   }
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/JobDao.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/JobDao.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/JobDao.cs	(revision 15908)
@@ -60,10 +60,10 @@
         (from job in db.GetTable<Job>()
          where job.State == jobState
-         select job).ToList());
+         select job));
     private static readonly Func<DataContext, JobState, IEnumerable<Guid>> GetJobIdsByStateQuery =
       CompiledQuery.Compile((DataContext db, JobState jobState) =>
         (from job in db.GetTable<Job>()
          where job.State == jobState
-         select job.JobId).ToList());
+         select job.JobId));
     private static readonly Func<DataContext, IEnumerable<Job>> GetJobsReadyForDeletionQuery =
       CompiledQuery.Compile((DataContext db) =>
@@ -75,5 +75,5 @@
               || task.State == TaskState.Aborted
               || task.State == TaskState.Failed).All(x => x)
-         select job).ToList());
+         select job));
     #endregion
 
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs	(revision 15908)
@@ -65,8 +65,8 @@
     /// <returns></returns>
     public IEnumerable<Task> GetParentTasks(IEnumerable<Guid> resourceIds, int count, bool finished) {
-      var query = from t in Table
-                  where t.State == TaskState.Waiting
+    var query = from t in Table
+                where t.State == TaskState.Waiting
                     && t.IsParentTask
-                    && !t.Job.AssignedJobResources.Select(x => x.ResourceId).Except(resourceIds).Any()
+                    && t.Job.AssignedJobResources.All(x => resourceIds.ToList().Contains(x.ResourceId))
                     && t.FinishWhenChildJobsFinished == finished
                     && t.ChildJobs.Any()
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 15908)
@@ -153,5 +153,4 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-    <Compile Include="Settings.cs" />
     <Compile Include="Settings.Designer.cs">
       <AutoGen>True</AutoGen>
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 15908)
@@ -37,5 +37,5 @@
       <Column Name="HbInterval" Type="System.Int32" DbType="Int" CanBeNull="false" />
       <Column Name="OwnerUserId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="true" />
-      <Association Name="Resource_AssignedProjectResource" Member="AssignedProjectResources" Storage="_AssignedResources" ThisKey="ResourceId" OtherKey="ResourceId" Type="AssignedProjectResource" />
+      <Association Name="Resource_AssignedProjectResource" Member="AssignedProjectResources" ThisKey="ResourceId" OtherKey="ResourceId" Type="AssignedProjectResource" />
       <Association Name="Resource_Resource" Member="ChildResources" ThisKey="ResourceId" OtherKey="ParentResourceId" Type="Resource" />
       <Association Name="Resource_Downtime" Member="Downtimes" Storage="_UptimeCalendars" ThisKey="ResourceId" OtherKey="ResourceId" Type="Downtime" />
@@ -261,5 +261,5 @@
       <Column Name="StartDate" Type="System.DateTime" DbType="DateTime NOT NULL" CanBeNull="false" />
       <Column Name="EndDate" Type="System.DateTime" DbType="DateTime" CanBeNull="true" />
-      <Association Name="Project_AssignedProjectResource" Member="AssignedProjectResources" Storage="_AssignedResources" ThisKey="ProjectId" OtherKey="ProjectId" Type="AssignedProjectResource" />
+      <Association Name="Project_AssignedProjectResource" Member="AssignedProjectResources" ThisKey="ProjectId" OtherKey="ProjectId" Type="AssignedProjectResource" />
       <Association Name="Project_Job" Member="Jobs" ThisKey="ProjectId" OtherKey="ProjectId" Type="Job" />
       <Association Name="Project_Project" Member="ChildProjects" Storage="_Projects" ThisKey="ProjectId" OtherKey="ParentProjectId" Type="Project" />
@@ -284,5 +284,5 @@
     </Type>
   </Table>
-  <Table Name="" Member="FactProjectInfos">
+  <Table Name="[statistics].FactProjectInfo" Member="FactProjectInfos">
     <Type Name="FactProjectInfo">
       <Column Name="ProjectId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" CanBeNull="false" />
@@ -296,5 +296,5 @@
     </Type>
   </Table>
-  <Table Name="" Member="DimProjects">
+  <Table Name="[statistics].DimProject" Member="DimProjects">
     <Type Name="DimProject">
       <Column Name="Id" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 15908)
@@ -941,5 +941,5 @@
 		private System.Nullable<System.Guid> _OwnerUserId;
 		
-		private EntitySet<AssignedProjectResource> _AssignedResources;
+		private EntitySet<AssignedProjectResource> _AssignedProjectResources;
 		
 		private EntitySet<Resource> _ChildResources;
@@ -973,5 +973,5 @@
 		public Resource()
 		{
-			this._AssignedResources = new EntitySet<AssignedProjectResource>(new Action<AssignedProjectResource>(this.attach_AssignedResources), new Action<AssignedProjectResource>(this.detach_AssignedResources));
+			this._AssignedProjectResources = new EntitySet<AssignedProjectResource>(new Action<AssignedProjectResource>(this.attach_AssignedProjectResources), new Action<AssignedProjectResource>(this.detach_AssignedProjectResources));
 			this._ChildResources = new EntitySet<Resource>(new Action<Resource>(this.attach_ChildResources), new Action<Resource>(this.detach_ChildResources));
 			this._UptimeCalendars = new EntitySet<Downtime>(new Action<Downtime>(this.attach_UptimeCalendars), new Action<Downtime>(this.detach_UptimeCalendars));
@@ -1106,14 +1106,14 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_AssignedProjectResource", Storage="_AssignedResources", ThisKey="ResourceId", OtherKey="ResourceId")]
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_AssignedProjectResource", Storage="_AssignedProjectResources", ThisKey="ResourceId", OtherKey="ResourceId")]
 		public EntitySet<AssignedProjectResource> AssignedProjectResources
 		{
 			get
 			{
-				return this._AssignedResources;
-			}
-			set
-			{
-				this._AssignedResources.Assign(value);
+				return this._AssignedProjectResources;
+			}
+			set
+			{
+				this._AssignedProjectResources.Assign(value);
 			}
 		}
@@ -1225,5 +1225,5 @@
 		}
 		
-		private void attach_AssignedResources(AssignedProjectResource entity)
+		private void attach_AssignedProjectResources(AssignedProjectResource entity)
 		{
 			this.SendPropertyChanging();
@@ -1231,5 +1231,5 @@
 		}
 		
-		private void detach_AssignedResources(AssignedProjectResource entity)
+		private void detach_AssignedProjectResources(AssignedProjectResource entity)
 		{
 			this.SendPropertyChanging();
@@ -5651,5 +5651,5 @@
 		private System.Nullable<System.DateTime> _EndDate;
 		
-		private EntitySet<AssignedProjectResource> _AssignedResources;
+		private EntitySet<AssignedProjectResource> _AssignedProjectResources;
 		
 		private EntitySet<Job> _Jobs;
@@ -5685,5 +5685,5 @@
 		public Project()
 		{
-			this._AssignedResources = new EntitySet<AssignedProjectResource>(new Action<AssignedProjectResource>(this.attach_AssignedResources), new Action<AssignedProjectResource>(this.detach_AssignedResources));
+			this._AssignedProjectResources = new EntitySet<AssignedProjectResource>(new Action<AssignedProjectResource>(this.attach_AssignedProjectResources), new Action<AssignedProjectResource>(this.detach_AssignedProjectResources));
 			this._Jobs = new EntitySet<Job>(new Action<Job>(this.attach_Jobs), new Action<Job>(this.detach_Jobs));
 			this._Projects = new EntitySet<Project>(new Action<Project>(this.attach_Projects), new Action<Project>(this.detach_Projects));
@@ -5857,14 +5857,14 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Project_AssignedProjectResource", Storage="_AssignedResources", ThisKey="ProjectId", OtherKey="ProjectId")]
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Project_AssignedProjectResource", Storage="_AssignedProjectResources", ThisKey="ProjectId", OtherKey="ProjectId")]
 		public EntitySet<AssignedProjectResource> AssignedProjectResources
 		{
 			get
 			{
-				return this._AssignedResources;
-			}
-			set
-			{
-				this._AssignedResources.Assign(value);
+				return this._AssignedProjectResources;
+			}
+			set
+			{
+				this._AssignedProjectResources.Assign(value);
 			}
 		}
@@ -5963,5 +5963,5 @@
 		}
 		
-		private void attach_AssignedResources(AssignedProjectResource entity)
+		private void attach_AssignedProjectResources(AssignedProjectResource entity)
 		{
 			this.SendPropertyChanging();
@@ -5969,5 +5969,5 @@
 		}
 		
-		private void detach_AssignedResources(AssignedProjectResource entity)
+		private void detach_AssignedProjectResources(AssignedProjectResource entity)
 		{
 			this.SendPropertyChanging();
@@ -6331,5 +6331,5 @@
 	}
 	
-	[global::System.Data.Linq.Mapping.TableAttribute(Name="")]
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="[statistics].FactProjectInfo")]
 	public partial class FactProjectInfo : INotifyPropertyChanging, INotifyPropertyChanged
 	{
@@ -6595,5 +6595,5 @@
 	}
 	
-	[global::System.Data.Linq.Mapping.TableAttribute(Name="")]
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="[statistics].DimProject")]
 	public partial class DimProject : INotifyPropertyChanging, INotifyPropertyChanged
 	{
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.JanitorService/3.3/ProjectInstaller.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.JanitorService/3.3/ProjectInstaller.Designer.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive.JanitorService/3.3/ProjectInstaller.Designer.cs	(revision 15908)
@@ -50,5 +50,5 @@
       // serviceProcessInstaller1
       // 
-      this.serviceProcessInstaller1.Account = System.ServiceProcess.ServiceAccount.LocalSystem;
+      this.serviceProcessInstaller1.Account = System.ServiceProcess.ServiceAccount.NetworkService;
       this.serviceProcessInstaller1.Installers.AddRange(new System.Configuration.Install.Installer[] {
             this.serviceInstaller1});
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive/3.3/HiveService.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 15908)
@@ -391,8 +391,8 @@
 
           var job = jobDao.Save(newJob);
-          if (userPriorityDao.GetById(jobDto.OwnerUserId) == null) {
+          if (userPriorityDao.GetById(newJob.OwnerUserId) == null) {
             userPriorityDao.Save(new DA.UserPriority {
-              UserId = jobDto.OwnerUserId,
-              DateEnqueued = jobDto.DateCreated
+              UserId = newJob.OwnerUserId,
+              DateEnqueued = newJob.DateCreated
             });
           }
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 15908)
@@ -421,5 +421,5 @@
         let uStats = projectUsageStats.Where(x => x.ProjectId == dimp.ProjectId).SingleOrDefault()
         select new FactProjectInfo {
-            ProjectId = dimp.ProjectId,
+            ProjectId = dimp.Id,
             DimTime = newTime,
             NumTotalCores = aStats != null ? aStats.Cores : 0,
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 15907)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 15908)
@@ -36,5 +36,6 @@
     public IEnumerable<TableInformation> GetHiveTableInformation() {
       var tables = new List<string> {
-        "AssignedResources",
+        "AssignedJobResource",
+        "AssignedProjectResource",
         "Downtime",
         "Job",
@@ -43,7 +44,8 @@
         "Plugin",
         "PluginData",
+        "Project",
+        "ProjectPermission",
         "RequiredPlugins",
         "Resource",
-        "ResourcePermission",
         "StateLog",
         "Task",
@@ -65,7 +67,9 @@
         "statistics.DimClient",
         "statistics.DimJob",
+        "statistics.DimProject",
         "statistics.DimTime",
         "statistics.DimUser",
         "statistics.FactClientInfo",
+        "statistics.FactProjectInfo",
         "statistics.FactTask"
       };